"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.getEditionSize = exports.getEditionGpaBuilder = exports.safeFetchAllEdition = exports.fetchAllEdition = exports.safeFetchEdition = exports.fetchEdition = exports.deserializeEdition = exports.getEditionAccountDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const types_1 = require("../types");
function getEditionAccountDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([
        ['key', (0, types_1.getKeySerializer)(context)],
        ['parent', s.publicKey()],
        ['edition', s.u64()],
    ], { description: 'EditionAccountData' }), (value) => ({ ...value, key: types_1.Key.EditionV1 }));
}
exports.getEditionAccountDataSerializer = getEditionAccountDataSerializer;
function deserializeEdition(context, rawAccount) {
    return (0, umi_1.deserializeAccount)(rawAccount, getEditionAccountDataSerializer(context));
}
exports.deserializeEdition = deserializeEdition;
async function fetchEdition(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount(publicKey, options);
    (0, umi_1.assertAccountExists)(maybeAccount, 'Edition');
    return deserializeEdition(context, maybeAccount);
}
exports.fetchEdition = fetchEdition;
async function safeFetchEdition(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount(publicKey, options);
    return maybeAccount.exists ? deserializeEdition(context, maybeAccount) : null;
}
exports.safeFetchEdition = safeFetchEdition;
async function fetchAllEdition(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys, options);
    return maybeAccounts.map((maybeAccount) => {
        (0, umi_1.assertAccountExists)(maybeAccount, 'Edition');
        return deserializeEdition(context, maybeAccount);
    });
}
exports.fetchAllEdition = fetchAllEdition;
async function safeFetchAllEdition(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys, options);
    return maybeAccounts
        .filter((maybeAccount) => maybeAccount.exists)
        .map((maybeAccount) => deserializeEdition(context, maybeAccount));
}
exports.safeFetchAllEdition = safeFetchAllEdition;
function getEditionGpaBuilder(context) {
    const s = context.serializer;
    const programId = context.programs.getPublicKey('mplTokenMetadata', 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s');
    return (0, umi_1.gpaBuilder)(context, programId)
        .registerFields({
        key: [0, (0, types_1.getKeySerializer)(context)],
        parent: [1, s.publicKey()],
        edition: [33, s.u64()],
    })
        .deserializeUsing((account) => deserializeEdition(context, account))
        .whereField('key', types_1.Key.EditionV1);
}
exports.getEditionGpaBuilder = getEditionGpaBuilder;
function getEditionSize() {
    return 41;
}
exports.getEditionSize = getEditionSize;
//# sourceMappingURL=edition.js.map