"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.findMasterEditionPda = exports.getMasterEditionSize = exports.getMasterEditionGpaBuilder = exports.safeFetchAllMasterEdition = exports.fetchAllMasterEdition = exports.safeFetchMasterEdition = exports.fetchMasterEdition = exports.deserializeMasterEdition = exports.getMasterEditionAccountDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const types_1 = require("../types");
function getMasterEditionAccountDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([
        ['key', (0, types_1.getKeySerializer)(context)],
        ['supply', s.u64()],
        ['maxSupply', s.option(s.u64())],
    ], { description: 'MasterEditionAccountData' }), (value) => ({ ...value, key: types_1.Key.MasterEditionV2 }));
}
exports.getMasterEditionAccountDataSerializer = getMasterEditionAccountDataSerializer;
function deserializeMasterEdition(context, rawAccount) {
    return (0, umi_1.deserializeAccount)(rawAccount, getMasterEditionAccountDataSerializer(context));
}
exports.deserializeMasterEdition = deserializeMasterEdition;
async function fetchMasterEdition(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount(publicKey, options);
    (0, umi_1.assertAccountExists)(maybeAccount, 'MasterEdition');
    return deserializeMasterEdition(context, maybeAccount);
}
exports.fetchMasterEdition = fetchMasterEdition;
async function safeFetchMasterEdition(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount(publicKey, options);
    return maybeAccount.exists
        ? deserializeMasterEdition(context, maybeAccount)
        : null;
}
exports.safeFetchMasterEdition = safeFetchMasterEdition;
async function fetchAllMasterEdition(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys, options);
    return maybeAccounts.map((maybeAccount) => {
        (0, umi_1.assertAccountExists)(maybeAccount, 'MasterEdition');
        return deserializeMasterEdition(context, maybeAccount);
    });
}
exports.fetchAllMasterEdition = fetchAllMasterEdition;
async function safeFetchAllMasterEdition(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys, options);
    return maybeAccounts
        .filter((maybeAccount) => maybeAccount.exists)
        .map((maybeAccount) => deserializeMasterEdition(context, maybeAccount));
}
exports.safeFetchAllMasterEdition = safeFetchAllMasterEdition;
function getMasterEditionGpaBuilder(context) {
    const s = context.serializer;
    const programId = context.programs.getPublicKey('mplTokenMetadata', 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s');
    return (0, umi_1.gpaBuilder)(context, programId)
        .registerFields({
        key: [0, (0, types_1.getKeySerializer)(context)],
        supply: [1, s.u64()],
        maxSupply: [9, s.option(s.u64())],
    })
        .deserializeUsing((account) => deserializeMasterEdition(context, account))
        .whereField('key', types_1.Key.MasterEditionV2);
}
exports.getMasterEditionGpaBuilder = getMasterEditionGpaBuilder;
function getMasterEditionSize() {
    return 282;
}
exports.getMasterEditionSize = getMasterEditionSize;
function findMasterEditionPda(context, seeds) {
    const s = context.serializer;
    const programId = context.programs.getPublicKey('mplTokenMetadata', 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s');
    return context.eddsa.findPda(programId, [
        s.string({ size: 'variable' }).serialize('metadata'),
        programId.bytes,
        s.publicKey().serialize(seeds.mint),
        s.string({ size: 'variable' }).serialize('edition'),
    ]);
}
exports.findMasterEditionPda = findMasterEditionPda;
//# sourceMappingURL=masterEdition.js.map