/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
import { Account, Context, Option, Pda, PublicKey, RpcAccount, RpcGetAccountOptions, RpcGetAccountsOptions, Serializer } from '@metaplex-foundation/umi';
import { Collection, CollectionArgs, CollectionDetails, CollectionDetailsArgs, Creator, CreatorArgs, Key, KeyArgs, ProgrammableConfig, ProgrammableConfigArgs, TokenStandard, TokenStandardArgs, Uses, UsesArgs } from '../types';
export type Metadata = Account<MetadataAccountData>;
export type MetadataAccountData = {
    key: Key;
    updateAuthority: PublicKey;
    mint: PublicKey;
    name: string;
    symbol: string;
    uri: string;
    sellerFeeBasisPoints: number;
    creators: Option<Array<Creator>>;
    primarySaleHappened: boolean;
    isMutable: boolean;
    editionNonce: Option<number>;
    tokenStandard: Option<TokenStandard>;
    collection: Option<Collection>;
    uses: Option<Uses>;
    collectionDetails: Option<CollectionDetails>;
    programmableConfig: Option<ProgrammableConfig>;
};
export type MetadataAccountDataArgs = {
    updateAuthority: PublicKey;
    mint: PublicKey;
    name: string;
    symbol: string;
    uri: string;
    sellerFeeBasisPoints: number;
    creators: Option<Array<CreatorArgs>>;
    primarySaleHappened: boolean;
    isMutable: boolean;
    editionNonce: Option<number>;
    tokenStandard: Option<TokenStandardArgs>;
    collection: Option<CollectionArgs>;
    uses: Option<UsesArgs>;
    collectionDetails: Option<CollectionDetailsArgs>;
    programmableConfig: Option<ProgrammableConfigArgs>;
};
export declare function getMetadataAccountDataSerializer(context: Pick<Context, 'serializer'>): Serializer<MetadataAccountDataArgs, MetadataAccountData>;
export declare function deserializeMetadata(context: Pick<Context, 'serializer'>, rawAccount: RpcAccount): Metadata;
export declare function fetchMetadata(context: Pick<Context, 'rpc' | 'serializer'>, publicKey: PublicKey, options?: RpcGetAccountOptions): Promise<Metadata>;
export declare function safeFetchMetadata(context: Pick<Context, 'rpc' | 'serializer'>, publicKey: PublicKey, options?: RpcGetAccountOptions): Promise<Metadata | null>;
export declare function fetchAllMetadata(context: Pick<Context, 'rpc' | 'serializer'>, publicKeys: PublicKey[], options?: RpcGetAccountsOptions): Promise<Metadata[]>;
export declare function safeFetchAllMetadata(context: Pick<Context, 'rpc' | 'serializer'>, publicKeys: PublicKey[], options?: RpcGetAccountsOptions): Promise<Metadata[]>;
export declare function getMetadataGpaBuilder(context: Pick<Context, 'rpc' | 'serializer' | 'programs'>): import("@metaplex-foundation/umi").GpaBuilder<Metadata, {
    key: KeyArgs;
    updateAuthority: PublicKey;
    mint: PublicKey;
    name: string;
    symbol: string;
    uri: string;
    sellerFeeBasisPoints: number;
    creators: Option<Array<CreatorArgs>>;
    primarySaleHappened: boolean;
    isMutable: boolean;
    editionNonce: Option<number>;
    tokenStandard: Option<TokenStandardArgs>;
    collection: Option<CollectionArgs>;
    uses: Option<UsesArgs>;
    collectionDetails: Option<CollectionDetailsArgs>;
    programmableConfig: Option<ProgrammableConfigArgs>;
}>;
export declare function getMetadataSize(): number;
export declare function findMetadataPda(context: Pick<Context, 'eddsa' | 'programs' | 'serializer'>, seeds: {
    /** The address of the mint account */
    mint: PublicKey;
}): Pda;
