"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.findMetadataPda = exports.getMetadataSize = exports.getMetadataGpaBuilder = exports.safeFetchAllMetadata = exports.fetchAllMetadata = exports.safeFetchMetadata = exports.fetchMetadata = exports.deserializeMetadata = exports.getMetadataAccountDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const types_1 = require("../types");
function getMetadataAccountDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([
        ['key', (0, types_1.getKeySerializer)(context)],
        ['updateAuthority', s.publicKey()],
        ['mint', s.publicKey()],
        ['name', s.string()],
        ['symbol', s.string()],
        ['uri', s.string()],
        ['sellerFeeBasisPoints', s.u16()],
        ['creators', s.option(s.array((0, types_1.getCreatorSerializer)(context)))],
        ['primarySaleHappened', s.bool()],
        ['isMutable', s.bool()],
        ['editionNonce', s.option(s.u8())],
        ['tokenStandard', s.option((0, types_1.getTokenStandardSerializer)(context))],
        ['collection', s.option((0, types_1.getCollectionSerializer)(context))],
        ['uses', s.option((0, types_1.getUsesSerializer)(context))],
        [
            'collectionDetails',
            s.option((0, types_1.getCollectionDetailsSerializer)(context)),
        ],
        [
            'programmableConfig',
            s.option((0, types_1.getProgrammableConfigSerializer)(context)),
        ],
    ], { description: 'MetadataAccountData' }), (value) => ({ ...value, key: types_1.Key.MetadataV1 }));
}
exports.getMetadataAccountDataSerializer = getMetadataAccountDataSerializer;
function deserializeMetadata(context, rawAccount) {
    return (0, umi_1.deserializeAccount)(rawAccount, getMetadataAccountDataSerializer(context));
}
exports.deserializeMetadata = deserializeMetadata;
async function fetchMetadata(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount(publicKey, options);
    (0, umi_1.assertAccountExists)(maybeAccount, 'Metadata');
    return deserializeMetadata(context, maybeAccount);
}
exports.fetchMetadata = fetchMetadata;
async function safeFetchMetadata(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount(publicKey, options);
    return maybeAccount.exists
        ? deserializeMetadata(context, maybeAccount)
        : null;
}
exports.safeFetchMetadata = safeFetchMetadata;
async function fetchAllMetadata(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys, options);
    return maybeAccounts.map((maybeAccount) => {
        (0, umi_1.assertAccountExists)(maybeAccount, 'Metadata');
        return deserializeMetadata(context, maybeAccount);
    });
}
exports.fetchAllMetadata = fetchAllMetadata;
async function safeFetchAllMetadata(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys, options);
    return maybeAccounts
        .filter((maybeAccount) => maybeAccount.exists)
        .map((maybeAccount) => deserializeMetadata(context, maybeAccount));
}
exports.safeFetchAllMetadata = safeFetchAllMetadata;
function getMetadataGpaBuilder(context) {
    const s = context.serializer;
    const programId = context.programs.getPublicKey('mplTokenMetadata', 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s');
    return (0, umi_1.gpaBuilder)(context, programId)
        .registerFields({
        key: [0, (0, types_1.getKeySerializer)(context)],
        updateAuthority: [1, s.publicKey()],
        mint: [33, s.publicKey()],
        name: [65, s.string()],
        symbol: [null, s.string()],
        uri: [null, s.string()],
        sellerFeeBasisPoints: [null, s.u16()],
        creators: [null, s.option(s.array((0, types_1.getCreatorSerializer)(context)))],
        primarySaleHappened: [null, s.bool()],
        isMutable: [null, s.bool()],
        editionNonce: [null, s.option(s.u8())],
        tokenStandard: [null, s.option((0, types_1.getTokenStandardSerializer)(context))],
        collection: [null, s.option((0, types_1.getCollectionSerializer)(context))],
        uses: [null, s.option((0, types_1.getUsesSerializer)(context))],
        collectionDetails: [
            null,
            s.option((0, types_1.getCollectionDetailsSerializer)(context)),
        ],
        programmableConfig: [
            null,
            s.option((0, types_1.getProgrammableConfigSerializer)(context)),
        ],
    })
        .deserializeUsing((account) => deserializeMetadata(context, account))
        .whereField('key', types_1.Key.MetadataV1);
}
exports.getMetadataGpaBuilder = getMetadataGpaBuilder;
function getMetadataSize() {
    return 679;
}
exports.getMetadataSize = getMetadataSize;
function findMetadataPda(context, seeds) {
    const s = context.serializer;
    const programId = context.programs.getPublicKey('mplTokenMetadata', 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s');
    return context.eddsa.findPda(programId, [
        s.string({ size: 'variable' }).serialize('metadata'),
        programId.bytes,
        s.publicKey().serialize(seeds.mint),
    ]);
}
exports.findMetadataPda = findMetadataPda;
//# sourceMappingURL=metadata.js.map