"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.getTokenOwnedEscrowGpaBuilder = exports.safeFetchAllTokenOwnedEscrow = exports.fetchAllTokenOwnedEscrow = exports.safeFetchTokenOwnedEscrow = exports.fetchTokenOwnedEscrow = exports.deserializeTokenOwnedEscrow = exports.getTokenOwnedEscrowAccountDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const types_1 = require("../types");
function getTokenOwnedEscrowAccountDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([
        ['key', (0, types_1.getKeySerializer)(context)],
        ['baseToken', s.publicKey()],
        ['authority', (0, types_1.getEscrowAuthoritySerializer)(context)],
        ['bump', s.u8()],
    ], { description: 'TokenOwnedEscrowAccountData' }), (value) => ({ ...value, key: types_1.Key.TokenOwnedEscrow }));
}
exports.getTokenOwnedEscrowAccountDataSerializer = getTokenOwnedEscrowAccountDataSerializer;
function deserializeTokenOwnedEscrow(context, rawAccount) {
    return (0, umi_1.deserializeAccount)(rawAccount, getTokenOwnedEscrowAccountDataSerializer(context));
}
exports.deserializeTokenOwnedEscrow = deserializeTokenOwnedEscrow;
async function fetchTokenOwnedEscrow(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount(publicKey, options);
    (0, umi_1.assertAccountExists)(maybeAccount, 'TokenOwnedEscrow');
    return deserializeTokenOwnedEscrow(context, maybeAccount);
}
exports.fetchTokenOwnedEscrow = fetchTokenOwnedEscrow;
async function safeFetchTokenOwnedEscrow(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount(publicKey, options);
    return maybeAccount.exists
        ? deserializeTokenOwnedEscrow(context, maybeAccount)
        : null;
}
exports.safeFetchTokenOwnedEscrow = safeFetchTokenOwnedEscrow;
async function fetchAllTokenOwnedEscrow(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys, options);
    return maybeAccounts.map((maybeAccount) => {
        (0, umi_1.assertAccountExists)(maybeAccount, 'TokenOwnedEscrow');
        return deserializeTokenOwnedEscrow(context, maybeAccount);
    });
}
exports.fetchAllTokenOwnedEscrow = fetchAllTokenOwnedEscrow;
async function safeFetchAllTokenOwnedEscrow(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys, options);
    return maybeAccounts
        .filter((maybeAccount) => maybeAccount.exists)
        .map((maybeAccount) => deserializeTokenOwnedEscrow(context, maybeAccount));
}
exports.safeFetchAllTokenOwnedEscrow = safeFetchAllTokenOwnedEscrow;
function getTokenOwnedEscrowGpaBuilder(context) {
    const s = context.serializer;
    const programId = context.programs.getPublicKey('mplTokenMetadata', 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s');
    return (0, umi_1.gpaBuilder)(context, programId)
        .registerFields({
        key: [0, (0, types_1.getKeySerializer)(context)],
        baseToken: [1, s.publicKey()],
        authority: [33, (0, types_1.getEscrowAuthoritySerializer)(context)],
        bump: [null, s.u8()],
    })
        .deserializeUsing((account) => deserializeTokenOwnedEscrow(context, account))
        .whereField('key', types_1.Key.TokenOwnedEscrow);
}
exports.getTokenOwnedEscrowGpaBuilder = getTokenOwnedEscrowGpaBuilder;
//# sourceMappingURL=tokenOwnedEscrow.js.map