"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.findTokenRecordPda = exports.getTokenRecordSize = exports.getTokenRecordGpaBuilder = exports.safeFetchAllTokenRecord = exports.fetchAllTokenRecord = exports.safeFetchTokenRecord = exports.fetchTokenRecord = exports.deserializeTokenRecord = exports.getTokenRecordAccountDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const types_1 = require("../types");
function getTokenRecordAccountDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([
        ['key', (0, types_1.getKeySerializer)(context)],
        ['bump', s.u8()],
        ['state', (0, types_1.getTokenStateSerializer)(context)],
        ['ruleSetRevision', s.option(s.u64())],
        ['delegate', s.option(s.publicKey())],
        ['delegateRole', s.option((0, types_1.getTokenDelegateRoleSerializer)(context))],
        ['lockedTransfer', s.option(s.publicKey())],
    ], { description: 'TokenRecordAccountData' }), (value) => ({ ...value, key: types_1.Key.TokenRecord }));
}
exports.getTokenRecordAccountDataSerializer = getTokenRecordAccountDataSerializer;
function deserializeTokenRecord(context, rawAccount) {
    return (0, umi_1.deserializeAccount)(rawAccount, getTokenRecordAccountDataSerializer(context));
}
exports.deserializeTokenRecord = deserializeTokenRecord;
async function fetchTokenRecord(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount(publicKey, options);
    (0, umi_1.assertAccountExists)(maybeAccount, 'TokenRecord');
    return deserializeTokenRecord(context, maybeAccount);
}
exports.fetchTokenRecord = fetchTokenRecord;
async function safeFetchTokenRecord(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount(publicKey, options);
    return maybeAccount.exists
        ? deserializeTokenRecord(context, maybeAccount)
        : null;
}
exports.safeFetchTokenRecord = safeFetchTokenRecord;
async function fetchAllTokenRecord(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys, options);
    return maybeAccounts.map((maybeAccount) => {
        (0, umi_1.assertAccountExists)(maybeAccount, 'TokenRecord');
        return deserializeTokenRecord(context, maybeAccount);
    });
}
exports.fetchAllTokenRecord = fetchAllTokenRecord;
async function safeFetchAllTokenRecord(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys, options);
    return maybeAccounts
        .filter((maybeAccount) => maybeAccount.exists)
        .map((maybeAccount) => deserializeTokenRecord(context, maybeAccount));
}
exports.safeFetchAllTokenRecord = safeFetchAllTokenRecord;
function getTokenRecordGpaBuilder(context) {
    const s = context.serializer;
    const programId = context.programs.getPublicKey('mplTokenMetadata', 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s');
    return (0, umi_1.gpaBuilder)(context, programId)
        .registerFields({
        key: [0, (0, types_1.getKeySerializer)(context)],
        bump: [1, s.u8()],
        state: [2, (0, types_1.getTokenStateSerializer)(context)],
        ruleSetRevision: [3, s.option(s.u64())],
        delegate: [null, s.option(s.publicKey())],
        delegateRole: [null, s.option((0, types_1.getTokenDelegateRoleSerializer)(context))],
        lockedTransfer: [null, s.option(s.publicKey())],
    })
        .deserializeUsing((account) => deserializeTokenRecord(context, account))
        .whereField('key', types_1.Key.TokenRecord);
}
exports.getTokenRecordGpaBuilder = getTokenRecordGpaBuilder;
function getTokenRecordSize() {
    return 80;
}
exports.getTokenRecordSize = getTokenRecordSize;
function findTokenRecordPda(context, seeds) {
    const s = context.serializer;
    const programId = context.programs.getPublicKey('mplTokenMetadata', 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s');
    return context.eddsa.findPda(programId, [
        s.string({ size: 'variable' }).serialize('metadata'),
        programId.bytes,
        s.publicKey().serialize(seeds.mint),
        s.string({ size: 'variable' }).serialize('token_record'),
        s.publicKey().serialize(seeds.token),
    ]);
}
exports.findTokenRecordPda = findTokenRecordPda;
//# sourceMappingURL=tokenRecord.js.map