"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.createEscrowAccount = exports.getCreateEscrowAccountInstructionDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const accounts_1 = require("../accounts");
const shared_1 = require("../shared");
function getCreateEscrowAccountInstructionDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([['discriminator', s.u8()]], {
        description: 'CreateEscrowAccountInstructionData',
    }), (value) => ({ ...value, discriminator: 38 }));
}
exports.getCreateEscrowAccountInstructionDataSerializer = getCreateEscrowAccountInstructionDataSerializer;
// Instruction.
function createEscrowAccount(context, input) {
    const signers = [];
    const keys = [];
    // Program ID.
    const programId = {
        ...context.programs.getPublicKey('mplTokenMetadata', 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s'),
        isWritable: false,
    };
    // Resolved inputs.
    const resolvingAccounts = {};
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'metadata', input.metadata ?? (0, accounts_1.findMetadataPda)(context, { mint: (0, umi_1.publicKey)(input.mint) }));
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'edition', input.edition ??
        (0, accounts_1.findMasterEditionPda)(context, { mint: (0, umi_1.publicKey)(input.mint) }));
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'payer', input.payer ?? context.payer);
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'systemProgram', input.systemProgram ?? {
        ...context.programs.getPublicKey('splSystem', '11111111111111111111111111111111'),
        isWritable: false,
    });
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'sysvarInstructions', input.sysvarInstructions ??
        (0, umi_1.publicKey)('Sysvar1nstructions1111111111111111111111111'));
    const resolvedAccounts = { ...input, ...resolvingAccounts };
    // Escrow.
    keys.push({
        pubkey: resolvedAccounts.escrow,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.escrow, true),
    });
    // Metadata.
    keys.push({
        pubkey: resolvedAccounts.metadata,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.metadata, true),
    });
    // Mint.
    keys.push({
        pubkey: resolvedAccounts.mint,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.mint, false),
    });
    // Token Account.
    keys.push({
        pubkey: resolvedAccounts.tokenAccount,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.tokenAccount, false),
    });
    // Edition.
    keys.push({
        pubkey: resolvedAccounts.edition,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.edition, false),
    });
    // Payer.
    signers.push(resolvedAccounts.payer);
    keys.push({
        pubkey: resolvedAccounts.payer.publicKey,
        isSigner: true,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.payer, true),
    });
    // System Program.
    keys.push({
        pubkey: resolvedAccounts.systemProgram,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.systemProgram, false),
    });
    // Sysvar Instructions.
    keys.push({
        pubkey: resolvedAccounts.sysvarInstructions,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.sysvarInstructions, false),
    });
    // Authority (optional).
    if (resolvedAccounts.authority) {
        signers.push(resolvedAccounts.authority);
        keys.push({
            pubkey: resolvedAccounts.authority.publicKey,
            isSigner: true,
            isWritable: (0, shared_1.isWritable)(resolvedAccounts.authority, false),
        });
    }
    // Data.
    const data = getCreateEscrowAccountInstructionDataSerializer(context).serialize({});
    // Bytes Created On Chain.
    const bytesCreatedOnChain = 0;
    return (0, umi_1.transactionBuilder)([
        { instruction: { keys, programId, data }, signers, bytesCreatedOnChain },
    ]);
}
exports.createEscrowAccount = createEscrowAccount;
//# sourceMappingURL=createEscrowAccount.js.map