"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.createMetadataAccount = exports.getCreateMetadataAccountInstructionDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const accounts_1 = require("../accounts");
const shared_1 = require("../shared");
const types_1 = require("../types");
function getCreateMetadataAccountInstructionDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([
        ['discriminator', s.u8()],
        [
            'data',
            s.struct([
                ['name', s.string()],
                ['symbol', s.string()],
                ['uri', s.string()],
                ['sellerFeeBasisPoints', s.u16()],
                ['creators', s.option(s.array((0, types_1.getCreatorSerializer)(context)))],
            ]),
        ],
        ['isMutable', s.bool()],
    ], { description: 'CreateMetadataAccountInstructionData' }), (value) => ({ ...value, discriminator: 0 }));
}
exports.getCreateMetadataAccountInstructionDataSerializer = getCreateMetadataAccountInstructionDataSerializer;
// Instruction.
function createMetadataAccount(context, input) {
    const signers = [];
    const keys = [];
    // Program ID.
    const programId = {
        ...context.programs.getPublicKey('mplTokenMetadata', 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s'),
        isWritable: false,
    };
    // Resolved inputs.
    const resolvingAccounts = {};
    const resolvingArgs = {};
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'metadata', input.metadata ?? (0, accounts_1.findMetadataPda)(context, { mint: (0, umi_1.publicKey)(input.mint) }));
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'payer', input.payer ?? context.payer);
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'updateAuthority', input.updateAuthority ?? context.identity.publicKey);
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'systemProgram', input.systemProgram ?? {
        ...context.programs.getPublicKey('splSystem', '11111111111111111111111111111111'),
        isWritable: false,
    });
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'rent', input.rent ?? (0, umi_1.publicKey)('SysvarRent111111111111111111111111111111111'));
    const resolvedAccounts = { ...input, ...resolvingAccounts };
    const resolvedArgs = { ...input, ...resolvingArgs };
    // Metadata.
    keys.push({
        pubkey: resolvedAccounts.metadata,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.metadata, true),
    });
    // Mint.
    keys.push({
        pubkey: resolvedAccounts.mint,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.mint, false),
    });
    // Mint Authority.
    signers.push(resolvedAccounts.mintAuthority);
    keys.push({
        pubkey: resolvedAccounts.mintAuthority.publicKey,
        isSigner: true,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.mintAuthority, false),
    });
    // Payer.
    signers.push(resolvedAccounts.payer);
    keys.push({
        pubkey: resolvedAccounts.payer.publicKey,
        isSigner: true,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.payer, true),
    });
    // Update Authority.
    keys.push({
        pubkey: resolvedAccounts.updateAuthority,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.updateAuthority, false),
    });
    // System Program.
    keys.push({
        pubkey: resolvedAccounts.systemProgram,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.systemProgram, false),
    });
    // Rent.
    keys.push({
        pubkey: resolvedAccounts.rent,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.rent, false),
    });
    // Data.
    const data = getCreateMetadataAccountInstructionDataSerializer(context).serialize(resolvedArgs);
    // Bytes Created On Chain.
    const bytesCreatedOnChain = 0;
    return (0, umi_1.transactionBuilder)([
        { instruction: { keys, programId, data }, signers, bytesCreatedOnChain },
    ]);
}
exports.createMetadataAccount = createMetadataAccount;
//# sourceMappingURL=createMetadataAccount.js.map