/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
import { Amount, Context, Option, PublicKey, Serializer, Signer, TransactionBuilder } from '@metaplex-foundation/umi';
import { PickPartial } from '../shared';
import { Collection, CollectionArgs, CollectionDetails, CollectionDetailsArgs, Creator, CreatorArgs, PrintSupply, PrintSupplyArgs, TokenStandard, TokenStandardArgs, Uses, UsesArgs } from '../types';
export type CreateV1InstructionAccounts = {
    /** Unallocated metadata account with address as pda of ['metadata', program id, mint id] */
    metadata?: PublicKey;
    /** Unallocated edition account with address as pda of ['metadata', program id, mint, 'edition'] */
    masterEdition?: PublicKey;
    /** Mint of token asset */
    mint: PublicKey | Signer;
    /** Mint authority */
    authority?: Signer;
    /** Payer */
    payer?: Signer;
    /** Update authority for the metadata account */
    updateAuthority?: PublicKey | Signer;
    /** System program */
    systemProgram?: PublicKey;
    /** Instructions sysvar account */
    sysvarInstructions?: PublicKey;
    /** SPL Token program */
    splTokenProgram?: PublicKey;
};
export type CreateV1InstructionData = {
    discriminator: number;
    createV1Discriminator: number;
    name: string;
    symbol: string;
    uri: string;
    sellerFeeBasisPoints: Amount<'%', 2>;
    creators: Option<Array<Creator>>;
    primarySaleHappened: boolean;
    isMutable: boolean;
    tokenStandard: TokenStandard;
    collection: Option<Collection>;
    uses: Option<Uses>;
    collectionDetails: Option<CollectionDetails>;
    ruleSet: Option<PublicKey>;
    decimals: Option<number>;
    printSupply: Option<PrintSupply>;
};
export type CreateV1InstructionDataArgs = {
    name: string;
    symbol?: string;
    uri: string;
    sellerFeeBasisPoints: Amount<'%', 2>;
    creators: Option<Array<CreatorArgs>>;
    primarySaleHappened?: boolean;
    isMutable?: boolean;
    tokenStandard: TokenStandardArgs;
    collection?: Option<CollectionArgs>;
    uses?: Option<UsesArgs>;
    collectionDetails?: Option<CollectionDetailsArgs>;
    ruleSet?: Option<PublicKey>;
    decimals?: Option<number>;
    printSupply?: Option<PrintSupplyArgs>;
};
export declare function getCreateV1InstructionDataSerializer(context: Pick<Context, 'serializer'>): Serializer<CreateV1InstructionDataArgs, CreateV1InstructionData>;
export type CreateV1InstructionExtraArgs = {
    isCollection: boolean;
};
export type CreateV1InstructionArgs = PickPartial<CreateV1InstructionDataArgs & CreateV1InstructionExtraArgs, 'tokenStandard' | 'isCollection' | 'collectionDetails' | 'decimals' | 'printSupply' | 'creators'>;
export declare function createV1(context: Pick<Context, 'serializer' | 'programs' | 'eddsa' | 'identity' | 'payer'>, input: CreateV1InstructionAccounts & CreateV1InstructionArgs): TransactionBuilder;
