"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.createV1 = exports.getCreateV1InstructionDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const hooked_1 = require("../../hooked");
const accounts_1 = require("../accounts");
const shared_1 = require("../shared");
const types_1 = require("../types");
function getCreateV1InstructionDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([
        ['discriminator', s.u8()],
        ['createV1Discriminator', s.u8()],
        ['name', s.string()],
        ['symbol', s.string()],
        ['uri', s.string()],
        ['sellerFeeBasisPoints', (0, umi_1.mapAmountSerializer)(s.u16(), '%', 2)],
        ['creators', s.option(s.array((0, types_1.getCreatorSerializer)(context)))],
        ['primarySaleHappened', s.bool()],
        ['isMutable', s.bool()],
        ['tokenStandard', (0, types_1.getTokenStandardSerializer)(context)],
        ['collection', s.option((0, types_1.getCollectionSerializer)(context))],
        ['uses', s.option((0, types_1.getUsesSerializer)(context))],
        [
            'collectionDetails',
            s.option((0, types_1.getCollectionDetailsSerializer)(context)),
        ],
        ['ruleSet', s.option(s.publicKey())],
        ['decimals', s.option(s.u8())],
        ['printSupply', s.option((0, types_1.getPrintSupplySerializer)(context))],
    ], { description: 'CreateV1InstructionData' }), (value) => ({
        ...value,
        discriminator: 42,
        createV1Discriminator: 0,
        symbol: value.symbol ?? '',
        primarySaleHappened: value.primarySaleHappened ?? false,
        isMutable: value.isMutable ?? true,
        collection: value.collection ?? (0, umi_1.none)(),
        uses: value.uses ?? (0, umi_1.none)(),
        collectionDetails: value.collectionDetails ?? (0, umi_1.none)(),
        ruleSet: value.ruleSet ?? (0, umi_1.none)(),
        decimals: value.decimals ?? (0, umi_1.none)(),
        printSupply: value.printSupply ?? (0, umi_1.none)(),
    }));
}
exports.getCreateV1InstructionDataSerializer = getCreateV1InstructionDataSerializer;
// Instruction.
function createV1(context, input) {
    const signers = [];
    const keys = [];
    // Program ID.
    const programId = {
        ...context.programs.getPublicKey('mplTokenMetadata', 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s'),
        isWritable: false,
    };
    // Resolved inputs.
    const resolvingAccounts = {};
    const resolvingArgs = {};
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'metadata', input.metadata ?? (0, accounts_1.findMetadataPda)(context, { mint: (0, umi_1.publicKey)(input.mint) }));
    (0, shared_1.addObjectProperty)(resolvingArgs, 'tokenStandard', input.tokenStandard ?? types_1.TokenStandard.NonFungible);
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'masterEdition', input.masterEdition ??
        (0, hooked_1.resolveMasterEdition)(context, { ...input, ...resolvingAccounts }, { ...input, ...resolvingArgs }, programId));
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'authority', input.authority ?? context.identity);
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'payer', input.payer ?? context.payer);
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'updateAuthority', input.updateAuthority ?? resolvingAccounts.authority);
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'systemProgram', input.systemProgram ?? {
        ...context.programs.getPublicKey('splSystem', '11111111111111111111111111111111'),
        isWritable: false,
    });
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'sysvarInstructions', input.sysvarInstructions ??
        (0, umi_1.publicKey)('Sysvar1nstructions1111111111111111111111111'));
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'splTokenProgram', input.splTokenProgram ?? {
        ...context.programs.getPublicKey('splToken', 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA'),
        isWritable: false,
    });
    (0, shared_1.addObjectProperty)(resolvingArgs, 'isCollection', input.isCollection ?? false);
    (0, shared_1.addObjectProperty)(resolvingArgs, 'collectionDetails', input.collectionDetails ??
        (0, hooked_1.resolveCollectionDetails)(context, { ...input, ...resolvingAccounts }, { ...input, ...resolvingArgs }, programId));
    (0, shared_1.addObjectProperty)(resolvingArgs, 'decimals', input.decimals ??
        (0, hooked_1.resolveDecimals)(context, { ...input, ...resolvingAccounts }, { ...input, ...resolvingArgs }, programId));
    (0, shared_1.addObjectProperty)(resolvingArgs, 'printSupply', input.printSupply ??
        (0, hooked_1.resolvePrintSupply)(context, { ...input, ...resolvingAccounts }, { ...input, ...resolvingArgs }, programId));
    (0, shared_1.addObjectProperty)(resolvingArgs, 'creators', input.creators ??
        (0, hooked_1.resolveCreators)(context, { ...input, ...resolvingAccounts }, { ...input, ...resolvingArgs }, programId));
    const resolvedAccounts = { ...input, ...resolvingAccounts };
    const resolvedArgs = { ...input, ...resolvingArgs };
    // Metadata.
    keys.push({
        pubkey: resolvedAccounts.metadata,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.metadata, true),
    });
    // Master Edition.
    keys.push({
        pubkey: resolvedAccounts.masterEdition,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.masterEdition, true),
    });
    // Mint.
    if ((0, umi_1.isSigner)(resolvedAccounts.mint)) {
        signers.push(resolvedAccounts.mint);
    }
    keys.push({
        pubkey: (0, umi_1.publicKey)(resolvedAccounts.mint),
        isSigner: (0, umi_1.isSigner)(resolvedAccounts.mint),
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.mint, true),
    });
    // Authority.
    signers.push(resolvedAccounts.authority);
    keys.push({
        pubkey: resolvedAccounts.authority.publicKey,
        isSigner: true,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.authority, false),
    });
    // Payer.
    signers.push(resolvedAccounts.payer);
    keys.push({
        pubkey: resolvedAccounts.payer.publicKey,
        isSigner: true,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.payer, true),
    });
    // Update Authority.
    if ((0, umi_1.isSigner)(resolvedAccounts.updateAuthority)) {
        signers.push(resolvedAccounts.updateAuthority);
    }
    keys.push({
        pubkey: (0, umi_1.publicKey)(resolvedAccounts.updateAuthority),
        isSigner: (0, umi_1.isSigner)(resolvedAccounts.updateAuthority),
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.updateAuthority, false),
    });
    // System Program.
    keys.push({
        pubkey: resolvedAccounts.systemProgram,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.systemProgram, false),
    });
    // Sysvar Instructions.
    keys.push({
        pubkey: resolvedAccounts.sysvarInstructions,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.sysvarInstructions, false),
    });
    // Spl Token Program.
    keys.push({
        pubkey: resolvedAccounts.splTokenProgram,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.splTokenProgram, false),
    });
    // Data.
    const data = getCreateV1InstructionDataSerializer(context).serialize(resolvedArgs);
    // Bytes Created On Chain.
    const bytesCreatedOnChain = (0, hooked_1.resolveCreateV1Bytes)(context, resolvedAccounts, resolvedArgs, programId);
    return (0, umi_1.transactionBuilder)([
        { instruction: { keys, programId, data }, signers, bytesCreatedOnChain },
    ]);
}
exports.createV1 = createV1;
//# sourceMappingURL=createV1.js.map