"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.migrateV1 = exports.getMigrateV1InstructionDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const accounts_1 = require("../accounts");
const shared_1 = require("../shared");
const types_1 = require("../types");
function getMigrateV1InstructionDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([
        ['discriminator', s.u8()],
        ['migrateV1Discriminator', s.u8()],
        ['migrationType', (0, types_1.getMigrationTypeSerializer)(context)],
        ['ruleSet', s.option(s.publicKey())],
    ], { description: 'MigrateV1InstructionData' }), (value) => ({
        ...value,
        discriminator: 48,
        migrateV1Discriminator: 0,
    }));
}
exports.getMigrateV1InstructionDataSerializer = getMigrateV1InstructionDataSerializer;
// Instruction.
function migrateV1(context, input) {
    const signers = [];
    const keys = [];
    // Program ID.
    const programId = {
        ...context.programs.getPublicKey('mplTokenMetadata', 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s'),
        isWritable: false,
    };
    // Resolved inputs.
    const resolvingAccounts = {};
    const resolvingArgs = {};
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'metadata', input.metadata ?? (0, accounts_1.findMetadataPda)(context, { mint: (0, umi_1.publicKey)(input.mint) }));
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'edition', input.edition ??
        (0, accounts_1.findMasterEditionPda)(context, { mint: (0, umi_1.publicKey)(input.mint) }));
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'payer', input.payer ?? context.payer);
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'authority', input.authority ?? context.identity);
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'tokenRecord', input.tokenRecord ??
        (0, accounts_1.findTokenRecordPda)(context, {
            mint: (0, umi_1.publicKey)(input.mint),
            token: (0, umi_1.publicKey)(input.token),
        }));
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'systemProgram', input.systemProgram ?? {
        ...context.programs.getPublicKey('splSystem', '11111111111111111111111111111111'),
        isWritable: false,
    });
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'sysvarInstructions', input.sysvarInstructions ??
        (0, umi_1.publicKey)('Sysvar1nstructions1111111111111111111111111'));
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'splTokenProgram', input.splTokenProgram ?? {
        ...context.programs.getPublicKey('splToken', 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA'),
        isWritable: false,
    });
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'authorizationRulesProgram', input.authorizationRulesProgram ?? programId);
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'authorizationRules', input.authorizationRules ?? programId);
    const resolvedAccounts = { ...input, ...resolvingAccounts };
    const resolvedArgs = { ...input, ...resolvingArgs };
    // Metadata.
    keys.push({
        pubkey: resolvedAccounts.metadata,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.metadata, true),
    });
    // Edition.
    keys.push({
        pubkey: resolvedAccounts.edition,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.edition, true),
    });
    // Token.
    keys.push({
        pubkey: resolvedAccounts.token,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.token, true),
    });
    // Token Owner.
    keys.push({
        pubkey: resolvedAccounts.tokenOwner,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.tokenOwner, false),
    });
    // Mint.
    keys.push({
        pubkey: resolvedAccounts.mint,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.mint, false),
    });
    // Payer.
    signers.push(resolvedAccounts.payer);
    keys.push({
        pubkey: resolvedAccounts.payer.publicKey,
        isSigner: true,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.payer, true),
    });
    // Authority.
    signers.push(resolvedAccounts.authority);
    keys.push({
        pubkey: resolvedAccounts.authority.publicKey,
        isSigner: true,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.authority, false),
    });
    // Collection Metadata.
    keys.push({
        pubkey: resolvedAccounts.collectionMetadata,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.collectionMetadata, false),
    });
    // Delegate Record.
    keys.push({
        pubkey: resolvedAccounts.delegateRecord,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.delegateRecord, false),
    });
    // Token Record.
    keys.push({
        pubkey: resolvedAccounts.tokenRecord,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.tokenRecord, true),
    });
    // System Program.
    keys.push({
        pubkey: resolvedAccounts.systemProgram,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.systemProgram, false),
    });
    // Sysvar Instructions.
    keys.push({
        pubkey: resolvedAccounts.sysvarInstructions,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.sysvarInstructions, false),
    });
    // Spl Token Program.
    keys.push({
        pubkey: resolvedAccounts.splTokenProgram,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.splTokenProgram, false),
    });
    // Authorization Rules Program.
    keys.push({
        pubkey: resolvedAccounts.authorizationRulesProgram,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.authorizationRulesProgram, false),
    });
    // Authorization Rules.
    keys.push({
        pubkey: resolvedAccounts.authorizationRules,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.authorizationRules, false),
    });
    // Data.
    const data = getMigrateV1InstructionDataSerializer(context).serialize(resolvedArgs);
    // Bytes Created On Chain.
    const bytesCreatedOnChain = 0;
    return (0, umi_1.transactionBuilder)([
        { instruction: { keys, programId, data }, signers, bytesCreatedOnChain },
    ]);
}
exports.migrateV1 = migrateV1;
//# sourceMappingURL=migrateV1.js.map