"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.mint = exports.getMintInstructionDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const accounts_1 = require("../accounts");
const shared_1 = require("../shared");
const types_1 = require("../types");
function getMintInstructionDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([
        ['discriminator', s.u8()],
        ['mintArgs', (0, types_1.getMintArgsSerializer)(context)],
    ], { description: 'MintInstructionData' }), (value) => ({ ...value, discriminator: 43 }));
}
exports.getMintInstructionDataSerializer = getMintInstructionDataSerializer;
// Instruction.
function mint(context, input) {
    const signers = [];
    const keys = [];
    // Program ID.
    const programId = {
        ...context.programs.getPublicKey('mplTokenMetadata', 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s'),
        isWritable: false,
    };
    // Resolved inputs.
    const resolvingAccounts = {};
    const resolvingArgs = {};
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'tokenOwner', input.tokenOwner ?? programId);
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'metadata', input.metadata ?? (0, accounts_1.findMetadataPda)(context, { mint: (0, umi_1.publicKey)(input.mint) }));
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'masterEdition', input.masterEdition ?? programId);
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'tokenRecord', input.tokenRecord ?? programId);
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'authority', input.authority ?? context.identity);
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'delegateRecord', input.delegateRecord ?? programId);
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'payer', input.payer ?? context.payer);
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'systemProgram', input.systemProgram ?? {
        ...context.programs.getPublicKey('splSystem', '11111111111111111111111111111111'),
        isWritable: false,
    });
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'sysvarInstructions', input.sysvarInstructions ??
        (0, umi_1.publicKey)('Sysvar1nstructions1111111111111111111111111'));
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'splTokenProgram', input.splTokenProgram ?? {
        ...context.programs.getPublicKey('splToken', 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA'),
        isWritable: false,
    });
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'splAtaProgram', input.splAtaProgram ?? {
        ...context.programs.getPublicKey('splAssociatedToken', 'ATokenGPvbdGVxr1b2hvZbsiqW5xWH25efTNsLJA8knL'),
        isWritable: false,
    });
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'authorizationRulesProgram', input.authorizationRulesProgram ?? programId);
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'authorizationRules', input.authorizationRules ?? programId);
    const resolvedAccounts = { ...input, ...resolvingAccounts };
    const resolvedArgs = { ...input, ...resolvingArgs };
    // Token.
    keys.push({
        pubkey: resolvedAccounts.token,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.token, true),
    });
    // Token Owner.
    keys.push({
        pubkey: resolvedAccounts.tokenOwner,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.tokenOwner, false),
    });
    // Metadata.
    keys.push({
        pubkey: resolvedAccounts.metadata,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.metadata, false),
    });
    // Master Edition.
    keys.push({
        pubkey: resolvedAccounts.masterEdition,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.masterEdition, true),
    });
    // Token Record.
    keys.push({
        pubkey: resolvedAccounts.tokenRecord,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.tokenRecord, true),
    });
    // Mint.
    keys.push({
        pubkey: resolvedAccounts.mint,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.mint, true),
    });
    // Authority.
    signers.push(resolvedAccounts.authority);
    keys.push({
        pubkey: resolvedAccounts.authority.publicKey,
        isSigner: true,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.authority, false),
    });
    // Delegate Record.
    keys.push({
        pubkey: resolvedAccounts.delegateRecord,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.delegateRecord, false),
    });
    // Payer.
    signers.push(resolvedAccounts.payer);
    keys.push({
        pubkey: resolvedAccounts.payer.publicKey,
        isSigner: true,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.payer, true),
    });
    // System Program.
    keys.push({
        pubkey: resolvedAccounts.systemProgram,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.systemProgram, false),
    });
    // Sysvar Instructions.
    keys.push({
        pubkey: resolvedAccounts.sysvarInstructions,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.sysvarInstructions, false),
    });
    // Spl Token Program.
    keys.push({
        pubkey: resolvedAccounts.splTokenProgram,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.splTokenProgram, false),
    });
    // Spl Ata Program.
    keys.push({
        pubkey: resolvedAccounts.splAtaProgram,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.splAtaProgram, false),
    });
    // Authorization Rules Program.
    keys.push({
        pubkey: resolvedAccounts.authorizationRulesProgram,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.authorizationRulesProgram, false),
    });
    // Authorization Rules.
    keys.push({
        pubkey: resolvedAccounts.authorizationRules,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.authorizationRules, false),
    });
    // Data.
    const data = getMintInstructionDataSerializer(context).serialize(resolvedArgs);
    // Bytes Created On Chain.
    const bytesCreatedOnChain = 468;
    return (0, umi_1.transactionBuilder)([
        { instruction: { keys, programId, data }, signers, bytesCreatedOnChain },
    ]);
}
exports.mint = mint;
//# sourceMappingURL=mint.js.map