"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.transferOutOfEscrow = exports.getTransferOutOfEscrowInstructionDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const shared_1 = require("../shared");
function getTransferOutOfEscrowInstructionDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([
        ['discriminator', s.u8()],
        ['amount', s.u64()],
    ], { description: 'TransferOutOfEscrowInstructionData' }), (value) => ({ ...value, discriminator: 40 }));
}
exports.getTransferOutOfEscrowInstructionDataSerializer = getTransferOutOfEscrowInstructionDataSerializer;
// Instruction.
function transferOutOfEscrow(context, input) {
    const signers = [];
    const keys = [];
    // Program ID.
    const programId = {
        ...context.programs.getPublicKey('mplTokenMetadata', 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s'),
        isWritable: false,
    };
    // Resolved inputs.
    const resolvingAccounts = {};
    const resolvingArgs = {};
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'payer', input.payer ?? context.payer);
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'systemProgram', input.systemProgram ?? {
        ...context.programs.getPublicKey('splSystem', '11111111111111111111111111111111'),
        isWritable: false,
    });
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'ataProgram', input.ataProgram ?? {
        ...context.programs.getPublicKey('splAssociatedToken', 'ATokenGPvbdGVxr1b2hvZbsiqW5xWH25efTNsLJA8knL'),
        isWritable: false,
    });
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'tokenProgram', input.tokenProgram ?? {
        ...context.programs.getPublicKey('splToken', 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA'),
        isWritable: false,
    });
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'sysvarInstructions', input.sysvarInstructions ??
        (0, umi_1.publicKey)('Sysvar1nstructions1111111111111111111111111'));
    const resolvedAccounts = { ...input, ...resolvingAccounts };
    const resolvedArgs = { ...input, ...resolvingArgs };
    // Escrow.
    keys.push({
        pubkey: resolvedAccounts.escrow,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.escrow, false),
    });
    // Metadata.
    keys.push({
        pubkey: resolvedAccounts.metadata,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.metadata, true),
    });
    // Payer.
    signers.push(resolvedAccounts.payer);
    keys.push({
        pubkey: resolvedAccounts.payer.publicKey,
        isSigner: true,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.payer, true),
    });
    // Attribute Mint.
    keys.push({
        pubkey: resolvedAccounts.attributeMint,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.attributeMint, false),
    });
    // Attribute Src.
    keys.push({
        pubkey: resolvedAccounts.attributeSrc,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.attributeSrc, true),
    });
    // Attribute Dst.
    keys.push({
        pubkey: resolvedAccounts.attributeDst,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.attributeDst, true),
    });
    // Escrow Mint.
    keys.push({
        pubkey: resolvedAccounts.escrowMint,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.escrowMint, false),
    });
    // Escrow Account.
    keys.push({
        pubkey: resolvedAccounts.escrowAccount,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.escrowAccount, false),
    });
    // System Program.
    keys.push({
        pubkey: resolvedAccounts.systemProgram,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.systemProgram, false),
    });
    // Ata Program.
    keys.push({
        pubkey: resolvedAccounts.ataProgram,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.ataProgram, false),
    });
    // Token Program.
    keys.push({
        pubkey: resolvedAccounts.tokenProgram,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.tokenProgram, false),
    });
    // Sysvar Instructions.
    keys.push({
        pubkey: resolvedAccounts.sysvarInstructions,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.sysvarInstructions, false),
    });
    // Authority (optional).
    if (resolvedAccounts.authority) {
        signers.push(resolvedAccounts.authority);
        keys.push({
            pubkey: resolvedAccounts.authority.publicKey,
            isSigner: true,
            isWritable: (0, shared_1.isWritable)(resolvedAccounts.authority, false),
        });
    }
    // Data.
    const data = getTransferOutOfEscrowInstructionDataSerializer(context).serialize(resolvedArgs);
    // Bytes Created On Chain.
    const bytesCreatedOnChain = 0;
    return (0, umi_1.transactionBuilder)([
        { instruction: { keys, programId, data }, signers, bytesCreatedOnChain },
    ]);
}
exports.transferOutOfEscrow = transferOutOfEscrow;
//# sourceMappingURL=transferOutOfEscrow.js.map