/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
import { Context, Option, PublicKey, Serializer, Signer, TransactionBuilder } from '@metaplex-foundation/umi';
import { AuthorizationData, AuthorizationDataArgs } from '../types';
export type TransferV1InstructionAccounts = {
    /** Token account */
    token: PublicKey;
    /** Token account owner */
    tokenOwner: PublicKey;
    /** Destination token account */
    destination: PublicKey;
    /** Destination token account owner */
    destinationOwner: PublicKey;
    /** Mint of token asset */
    mint: PublicKey;
    /** Metadata (pda of ['metadata', program id, mint id]) */
    metadata?: PublicKey;
    /** Edition of token asset */
    edition?: PublicKey;
    /** Owner token record account */
    ownerTokenRecord?: PublicKey;
    /** Destination token record account */
    destinationTokenRecord?: PublicKey;
    /** Transfer authority (token owner or delegate) */
    authority?: Signer;
    /** Payer */
    payer?: Signer;
    /** System Program */
    systemProgram?: PublicKey;
    /** Instructions sysvar account */
    sysvarInstructions?: PublicKey;
    /** SPL Token Program */
    splTokenProgram?: PublicKey;
    /** SPL Associated Token Account program */
    splAtaProgram?: PublicKey;
    /** Token Authorization Rules Program */
    authorizationRulesProgram?: PublicKey;
    /** Token Authorization Rules account */
    authorizationRules?: PublicKey;
};
export type TransferV1InstructionData = {
    discriminator: number;
    transferV1Discriminator: number;
    amount: bigint;
    authorizationData: Option<AuthorizationData>;
};
export type TransferV1InstructionDataArgs = {
    amount: number | bigint;
    authorizationData: Option<AuthorizationDataArgs>;
};
export declare function getTransferV1InstructionDataSerializer(context: Pick<Context, 'serializer'>): Serializer<TransferV1InstructionDataArgs, TransferV1InstructionData>;
export type TransferV1InstructionArgs = TransferV1InstructionDataArgs;
export declare function transferV1(context: Pick<Context, 'serializer' | 'programs' | 'eddsa' | 'identity' | 'payer'>, input: TransferV1InstructionAccounts & TransferV1InstructionArgs): TransactionBuilder;
