"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.utilize = exports.getUtilizeInstructionDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const accounts_1 = require("../accounts");
const shared_1 = require("../shared");
function getUtilizeInstructionDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([
        ['discriminator', s.u8()],
        ['numberOfUses', s.u64()],
    ], { description: 'UtilizeInstructionData' }), (value) => ({ ...value, discriminator: 19 }));
}
exports.getUtilizeInstructionDataSerializer = getUtilizeInstructionDataSerializer;
// Instruction.
function utilize(context, input) {
    const signers = [];
    const keys = [];
    // Program ID.
    const programId = {
        ...context.programs.getPublicKey('mplTokenMetadata', 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s'),
        isWritable: false,
    };
    // Resolved inputs.
    const resolvingAccounts = {};
    const resolvingArgs = {};
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'metadata', input.metadata ?? (0, accounts_1.findMetadataPda)(context, { mint: (0, umi_1.publicKey)(input.mint) }));
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'tokenProgram', input.tokenProgram ?? {
        ...context.programs.getPublicKey('splToken', 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA'),
        isWritable: false,
    });
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'ataProgram', input.ataProgram ?? {
        ...context.programs.getPublicKey('splAssociatedToken', 'ATokenGPvbdGVxr1b2hvZbsiqW5xWH25efTNsLJA8knL'),
        isWritable: false,
    });
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'systemProgram', input.systemProgram ?? {
        ...context.programs.getPublicKey('splSystem', '11111111111111111111111111111111'),
        isWritable: false,
    });
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'rent', input.rent ?? (0, umi_1.publicKey)('SysvarRent111111111111111111111111111111111'));
    const resolvedAccounts = { ...input, ...resolvingAccounts };
    const resolvedArgs = { ...input, ...resolvingArgs };
    // Metadata.
    keys.push({
        pubkey: resolvedAccounts.metadata,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.metadata, true),
    });
    // Token Account.
    keys.push({
        pubkey: resolvedAccounts.tokenAccount,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.tokenAccount, true),
    });
    // Mint.
    keys.push({
        pubkey: resolvedAccounts.mint,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.mint, true),
    });
    // Use Authority.
    signers.push(resolvedAccounts.useAuthority);
    keys.push({
        pubkey: resolvedAccounts.useAuthority.publicKey,
        isSigner: true,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.useAuthority, true),
    });
    // Owner.
    keys.push({
        pubkey: resolvedAccounts.owner,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.owner, false),
    });
    // Token Program.
    keys.push({
        pubkey: resolvedAccounts.tokenProgram,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.tokenProgram, false),
    });
    // Ata Program.
    keys.push({
        pubkey: resolvedAccounts.ataProgram,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.ataProgram, false),
    });
    // System Program.
    keys.push({
        pubkey: resolvedAccounts.systemProgram,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.systemProgram, false),
    });
    // Rent.
    keys.push({
        pubkey: resolvedAccounts.rent,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.rent, false),
    });
    // Use Authority Record (optional).
    if (resolvedAccounts.useAuthorityRecord) {
        keys.push({
            pubkey: resolvedAccounts.useAuthorityRecord,
            isSigner: false,
            isWritable: (0, shared_1.isWritable)(resolvedAccounts.useAuthorityRecord, true),
        });
    }
    // Burner (optional).
    if (resolvedAccounts.burner) {
        keys.push({
            pubkey: resolvedAccounts.burner,
            isSigner: false,
            isWritable: (0, shared_1.isWritable)(resolvedAccounts.burner, false),
        });
    }
    // Data.
    const data = getUtilizeInstructionDataSerializer(context).serialize(resolvedArgs);
    // Bytes Created On Chain.
    const bytesCreatedOnChain = 0;
    return (0, umi_1.transactionBuilder)([
        { instruction: { keys, programId, data }, signers, bytesCreatedOnChain },
    ]);
}
exports.utilize = utilize;
//# sourceMappingURL=utilize.js.map