"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.verify = exports.getVerifyInstructionDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const shared_1 = require("../shared");
const types_1 = require("../types");
function getVerifyInstructionDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([
        ['discriminator', s.u8()],
        ['verificationArgs', (0, types_1.getVerificationArgsSerializer)(context)],
    ], { description: 'VerifyInstructionData' }), (value) => ({ ...value, discriminator: 52 }));
}
exports.getVerifyInstructionDataSerializer = getVerifyInstructionDataSerializer;
// Instruction.
function verify(context, input) {
    const signers = [];
    const keys = [];
    // Program ID.
    const programId = {
        ...context.programs.getPublicKey('mplTokenMetadata', 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s'),
        isWritable: false,
    };
    // Resolved inputs.
    const resolvingAccounts = {};
    const resolvingArgs = {};
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'authority', input.authority ?? context.identity);
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'delegateRecord', input.delegateRecord ?? programId);
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'collectionMint', input.collectionMint ?? programId);
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'collectionMetadata', input.collectionMetadata ?? programId);
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'collectionMasterEdition', input.collectionMasterEdition ?? programId);
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'systemProgram', input.systemProgram ?? {
        ...context.programs.getPublicKey('splSystem', '11111111111111111111111111111111'),
        isWritable: false,
    });
    (0, shared_1.addObjectProperty)(resolvingAccounts, 'sysvarInstructions', input.sysvarInstructions ??
        (0, umi_1.publicKey)('Sysvar1nstructions1111111111111111111111111'));
    const resolvedAccounts = { ...input, ...resolvingAccounts };
    const resolvedArgs = { ...input, ...resolvingArgs };
    // Authority.
    signers.push(resolvedAccounts.authority);
    keys.push({
        pubkey: resolvedAccounts.authority.publicKey,
        isSigner: true,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.authority, false),
    });
    // Delegate Record.
    keys.push({
        pubkey: resolvedAccounts.delegateRecord,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.delegateRecord, false),
    });
    // Metadata.
    keys.push({
        pubkey: resolvedAccounts.metadata,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.metadata, true),
    });
    // Collection Mint.
    keys.push({
        pubkey: resolvedAccounts.collectionMint,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.collectionMint, false),
    });
    // Collection Metadata.
    keys.push({
        pubkey: resolvedAccounts.collectionMetadata,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.collectionMetadata, true),
    });
    // Collection Master Edition.
    keys.push({
        pubkey: resolvedAccounts.collectionMasterEdition,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.collectionMasterEdition, false),
    });
    // System Program.
    keys.push({
        pubkey: resolvedAccounts.systemProgram,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.systemProgram, false),
    });
    // Sysvar Instructions.
    keys.push({
        pubkey: resolvedAccounts.sysvarInstructions,
        isSigner: false,
        isWritable: (0, shared_1.isWritable)(resolvedAccounts.sysvarInstructions, false),
    });
    // Data.
    const data = getVerifyInstructionDataSerializer(context).serialize(resolvedArgs);
    // Bytes Created On Chain.
    const bytesCreatedOnChain = 0;
    return (0, umi_1.transactionBuilder)([
        { instruction: { keys, programId, data }, signers, bytesCreatedOnChain },
    ]);
}
exports.verify = verify;
//# sourceMappingURL=verify.js.map