"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getMetadataDelegateRoleSeedSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const errors_1 = require("../errors");
const metadataDelegateRole_1 = require("../generated/types/metadataDelegateRole");
function getMetadataDelegateRoleSeedSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.string({ size: 'variable' }), (args) => {
        if (typeof args === 'string')
            return args;
        switch (args) {
            case metadataDelegateRole_1.MetadataDelegateRole.Authority:
                return 'authority_delegate';
            case metadataDelegateRole_1.MetadataDelegateRole.Collection:
                return 'collection_delegate';
            case metadataDelegateRole_1.MetadataDelegateRole.Use:
                return 'use_delegate';
            case metadataDelegateRole_1.MetadataDelegateRole.Update:
                return 'update_delegate';
            case metadataDelegateRole_1.MetadataDelegateRole.ProgrammableConfig:
                return 'programmable_config_delegate';
            default:
                throw new errors_1.TokenMetadataError(`Invalid MetadataDelegateRoleArgs ${args}`);
        }
    }, (seed) => seed);
}
exports.getMetadataDelegateRoleSeedSerializer = getMetadataDelegateRoleSeedSerializer;
//# sourceMappingURL=metadataDelegateRoleSeed.js.map