import { Context, Option, Pda, PublicKey, Signer } from '@metaplex-foundation/umi';
import { CollectionDetailsArgs, CreatorArgs, PrintSupplyArgs, TokenStandard } from '../generated';
export declare const resolveCollectionDetails: (context: any, accounts: any, args: {
    isCollection: boolean;
}, programId: any) => Option<CollectionDetailsArgs>;
export declare const resolveMasterEdition: (context: Pick<Context, 'eddsa' | 'serializer' | 'programs'>, accounts: {
    mint: PublicKey | Signer;
}, args: {
    tokenStandard: TokenStandard;
}, programId: PublicKey) => PublicKey | Pda;
export declare const resolveDecimals: (context: any, accounts: any, args: {
    tokenStandard: TokenStandard;
}, programId: any) => Option<number>;
export declare const resolvePrintSupply: (context: any, accounts: any, args: {
    tokenStandard: TokenStandard;
}, programId: any) => Option<PrintSupplyArgs>;
export declare const resolveCreators: (context: any, accounts: {
    authority: Signer;
}, args: any, programId: any) => Option<CreatorArgs[]>;
export declare const resolveCreateV1Bytes: (context: any, accounts: any, args: {
    tokenStandard: TokenStandard;
}, programId: any) => number;
export declare const resolveMintTokenOwner: (context: Pick<Context, 'identity'>, accounts: {
    token?: PublicKey;
}, args: any, programId: PublicKey) => PublicKey | Pda;
export declare const resolveTokenRecord: (context: Pick<Context, 'eddsa' | 'serializer' | 'programs'>, accounts: {
    mint: PublicKey | Signer;
    token: PublicKey;
}, args: {
    tokenStandard: TokenStandard;
}, programId: PublicKey) => PublicKey | Pda;
