"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.resolveTokenRecord = exports.resolveMintTokenOwner = exports.resolveCreateV1Bytes = exports.resolveCreators = exports.resolvePrintSupply = exports.resolveDecimals = exports.resolveMasterEdition = exports.resolveCollectionDetails = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const mpl_essentials_1 = require("@metaplex-foundation/mpl-essentials");
const digitalAsset_1 = require("../digitalAsset");
const generated_1 = require("../generated");
const resolveCollectionDetails = (context, accounts, args, programId) => args.isCollection ? (0, umi_1.some)((0, generated_1.collectionDetails)('V1', { size: 0 })) : (0, umi_1.none)();
exports.resolveCollectionDetails = resolveCollectionDetails;
const resolveMasterEdition = (context, accounts, args, programId) => (0, digitalAsset_1.isNonFungible)(args.tokenStandard)
    ? (0, generated_1.findMasterEditionPda)(context, { mint: (0, umi_1.publicKey)(accounts.mint) })
    : programId;
exports.resolveMasterEdition = resolveMasterEdition;
const resolveDecimals = (context, accounts, args, programId) => ((0, digitalAsset_1.isNonFungible)(args.tokenStandard) ? (0, umi_1.none)() : (0, umi_1.some)(0));
exports.resolveDecimals = resolveDecimals;
const resolvePrintSupply = (context, accounts, args, programId) => (0, digitalAsset_1.isNonFungible)(args.tokenStandard) ? (0, umi_1.some)((0, generated_1.printSupply)('Zero')) : (0, umi_1.none)();
exports.resolvePrintSupply = resolvePrintSupply;
const resolveCreators = (context, accounts, args, programId) => (0, umi_1.some)([
    { address: (0, umi_1.publicKey)(accounts.authority), share: 100, verified: true },
]);
exports.resolveCreators = resolveCreators;
const resolveCreateV1Bytes = (context, accounts, args, programId) => {
    const base = (0, mpl_essentials_1.getMintSize)() + (0, generated_1.getMetadataSize)() + 2 * umi_1.ACCOUNT_HEADER_SIZE;
    if ((0, digitalAsset_1.isNonFungible)(args.tokenStandard)) {
        return base + (0, generated_1.getMasterEditionSize)() + umi_1.ACCOUNT_HEADER_SIZE;
    }
    return base;
};
exports.resolveCreateV1Bytes = resolveCreateV1Bytes;
const resolveMintTokenOwner = (context, accounts, args, programId) => (accounts.token ? programId : context.identity.publicKey);
exports.resolveMintTokenOwner = resolveMintTokenOwner;
const resolveTokenRecord = (context, accounts, args, programId) => (0, digitalAsset_1.isProgrammable)(args.tokenStandard)
    ? (0, generated_1.findTokenRecordPda)(context, {
        mint: (0, umi_1.publicKey)(accounts.mint),
        token: accounts.token,
    })
    : programId;
exports.resolveTokenRecord = resolveTokenRecord;
//# sourceMappingURL=resolvers.js.map